<template>
  <div class="grid">
    <div class="col-12 md:col-4 wordlist-tree">
      <Tree :value="this.filters" scrollHeight="590px">
        <template #default="filter">
          {{ filter.node.label }}
        </template>
        <template #syllabel="filter">
          <InputNumber
            v-model="filterModels[filter.node.data]"
            class="treenode-label"
          />
        </template>
        <template #checkbox="filter">
          <TriStateCheckbox
            v-model="filterModels[filter.node.data]"
            class="treenode-label"
          />
          {{ filter.node.label }}
        </template>
      </Tree>

      <div class="mt-4">
        <div>
          <h3 v-if="$route.params.word != 'new' && filterName" class="mb-2" style="color: #000000">Nom du filtre : {{ filterName }}</h3>
          <div v-if="!$route.name.includes('collab')" class="mb-2">
            <Checkbox id="binary" v-model="collab" :binary="true" />
            <label class="ml-1 pointer" style="color: #000000" for="binary">Filtre collaboratif</label>
          </div>
          <div v-else>
            <p style="color: #000000">Vous pouvez voir les mots utilisés dans ce filtre collaboratif</p>
          </div>
          <Button v-if="$route.params.word == 'new'" class="p-button-success" :disabled="Object.keys(selectWords || {}).length < 10" label="Créer la liste de travail" @click="this.visible = true" />
          <Button :disabled="Object.keys(selectWords || {}).length < 10" v-if="!$route.name.includes('collab') && $route.params.word != 'new'" label="Enregistrer les modifications" @click="saveModification()" :loading="submitLoad" />
          <p v-if="submitError && $route.params.word != 'new'">{{ submitError }}</p>
        </div>

        <div class="mt-4">
          <div>
            <Button v-if="$route.params.word != 'new' && !$route.name.includes('collab')" @click="removeFil = !removeFil" class="p-button-danger" label="Supprimer le filtre"/>
          </div>
          <div class="mt-2">
            <router-link :to="`/patient/` + $route.params.id">
              <Button label="Retour fiche patient" />
            </router-link>
          </div>
        </div>

        <Dialog v-model:visible="removeFil">
          <template #header>
          <h3 class="warning">Supprimer le filtre</h3>
          </template>

          <p>Vous êtes sur le point de supprimer définitivement ce filtre</p>
          <p>Pour valider la suppression, veuillez cliquer sur "Supprimer"</p>

          <template #footer>
          <Button
              :loading="loadFilter"
              label="Supprimer"
              class="p-button-danger"
              @click="removeFilter()"
          />
          </template>
        </Dialog>
      </div>
    </div>
    <div class="col-12 md:col-8">
      <div class="grid">
        <div class="col-12" style="padding-right: 20px">
          <div class="flex justify-content-between align-items-center">
            <h3>Résultats</h3>
            <AddWordToDict />
         </div>
         <InputText type="text" style="width: 100%" placeholder="Rechercher dans le dictionnaire" v-model="searchWordDico" />
         <div class="gridFive">
            <div class="gridElem">Orthographe</div>
            <div class="gridElem">
              
            </div>
            <div class="gridElem">Nombre Syllabes</div>
            <div class="gridElem">Structure Syllabique</div>
            <div class="gridElem">Structure Syllabique type</div>
          </div>
          <div class="mainTable mt-2">
            <div class="mt-2" v-if="computedWords.length == 0">
              Aucun résultat disponible dans le dictionnaire
            </div>
            <div v-for="(item, index) in computedWords" :key="index">
              <div class="gridFive">
                <div class="gridElem"><strong>{{ item.orthographe }}</strong> <span class="ml-1 mr-1">-</span> <span v-for="(itt, idd) in item.phonem" :key="idd">{{ translate[itt] }}</span></div>
                <div class="gridElem">
                  <i v-if="item.id in selectWords" class="pi pi-check" />
                  <Button v-else-if="!$route.name.includes('collab')" @click="selectWords[item.id] = {id: item.id, phonem: item.phonem, orthographe: item.orthographe, nb_syll: item.nb_syll, struct_syll: item.struct_syll, struct_syll_type: item.struct_syll_type}" label="Sélectionner" class="p-button-sm"/>
                </div>
                <div class="gridElem">{{ item.nb_syll}}</div>
                <div class="gridElem">{{ item.struct_syll }}</div>
                <div class="gridElem">{{ item.struct_syll_type }}</div>
              </div>
            </div>
          </div>

          <div style="padding-right: 5px">
            <div class="gridTwo">
              <div>
                <p class="m-0">Nombre de résultats: {{ computedWords.length }}</p>
              </div>
              <div>
                <Button v-if="!$route.name.includes('collab')" @click="addAll()" :disabled="computedWords.length == 0" label="Ajouter tous les résultats" class="p-button-sm"/>
              </div>
            </div>
            <hr>
            <div class="gridTwo">
              <div>
                <h4 class="mt-0">Votre liste de travail ({{ Object.keys(selectWords || {}).length }})</h4>
              </div>
              <div>
                <Button v-if="!$route.name.includes('collab')" @click="selectWords = {}" :disabled="Object.keys(selectWords || {}).length.length == 0" label="Tout retirer" class="p-button-sm"/>
              </div>
            </div>

            <InputText type="text" style="width: 100%" placeholder="Rechercher dans la liste de travail" v-model="searchWordResult" />
            
            <div class="selectTable mt-2">
              <div class="mt-2" v-if="Object.keys(selectWords || {}).length == 0">
                Aucun mot dans la liste de travail
              </div>
              <div class="mt-2" v-if="Object.keys(selectWords || {}).length > 0 && searchWordResult.length > 0 && computedResult.length == 0">
                Aucun mot trouvé dans la liste de travail
              </div>
              <div v-for="(item, index) in computedResult" :key="index">
                <div class="gridFive">
                  <div class="gridElem"><strong>{{ item.orthographe }}</strong> <span class="ml-1 mr-1">-</span> <span v-for="(itt, idd) in item.phonem" :key="idd">{{ translate[itt] }}</span></div>
                  <div class="gridElem">
                    <Button v-if="!$route.name.includes('collab')" @click="delete selectWords[item.id]" label="Retirer" class="p-button-sm ml-2"/>
                  </div>
                  <div class="gridElem">{{ item.nb_syll}}</div>
                  <div class="gridElem">{{ item.struct_syll }}</div>
                  <div class="gridElem">{{ item.struct_syll_type }}</div>
                </div>
              </div>
            </div>

            <p v-if="Object.keys(selectWords || {}).length > 0 && Object.keys(selectWords || {}).length < 10" class="mb-2"><strong>Votre liste doit contenir un minimum de 10 mots</strong></p>
          </div>
          <div>
            <Dialog v-model:visible="this.visible">
              <template #header> Nom de la liste de travail </template>
              <InputText type="text" placeholder="Nom de la liste de travail" v-model="listName" />

              <p>La liste sera associée au patient actuel</p>
              <p v-if="submitError">{{ submitError }}</p>
              <template #footer>
                <Button @click="submitWordList()" :disabled="listName.length == 0" label="Valider" :loading="submitLoad" />
              </template>
            </Dialog>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import DataTable from "primevue/datatable";
import Checkbox from "primevue/checkbox";
import Column from "primevue/column";
import Tree from "primevue/tree";
import InputNumber from "primevue/inputnumber";
import TriStateCheckbox from "primevue/tristatecheckbox";
import Button from "primevue/button";
import Dialog from "primevue/dialog";
import InputText from "primevue/inputtext";
import AddWordToDict from "@/components/AddWordToDict.vue";

import axios from 'axios'

export default {
  name: "WordList",
  components: {
    DataTable,
    Column,
    Tree,
    InputNumber,
    TriStateCheckbox,
    Button,
    Dialog,
    InputText,
    Checkbox,
    AddWordToDict
  },
  data() {
    return {
      collab: false,
      translate: {
        "a": "a",
        "i": "i",
        "y": "y",
        "u": "u",
        "o": "o",
        "O": "ɔ",
        "e": "e",
        "E": "ɛ",
        "°": "ə",
        "2": "ø",
        "9": "œ",
        "1": "œ̃",
        "3": "",

        "5": "ɛ̃",
        "@": "ɑ̃",
        "§": "ɔ̃",

        "j": "j",
        "8": "ɥ",
        "w": "w",

        "p": "p",
        "b": "b",
        "t": "t",
        "d": "d",
        "k": "k",
        "g": "g",

        "f": "f",
        "v": "v",
        "s": "s",
        "z": "z",
        "S": "ʃ",
        "Z": "ʒ",

        "m": "m",
        "n": "n",
        "N": "ɲ",

        "l": "l",
        "R": "ʁ",

        "K": "ŋ",

        "x": "",
        "G": ""
      },
      removeFil: false,
      loadFilter: false,
      patient: {},

      listName: "",
      searchWordDico: "",
      searchWordResult: "",
      selectWords: {},

      visible: false,
      submitError: null,
      submitLoad: false,
      filterName: null,
      filterModels: {
        filterSyllabel: 0,
        filterCV: null,
        filterVC: null,
        filterCVCV: null,
        filterVCV: null,
        filterCVC: null,
        filterCVCVC: null,
        filterCVV: null,
        filterCC_init: null,
        filterCC_mid: null,
        filterCC_final: null,
        filterCCC_init: null,
        filterCCC_mid: null,
        filterCCC_final: null,
        filterPolysyllab: null,
        filterV: null,
        filterVCVC: null,
        filterVCVCV: null,
        filterVCVCVC: null,
        filterCsv: null,
        filterCo_sourd: null,
        filterCo_sonore: null,
        filterCc_sourd: null,
        filterCc_sonore: null,
        filterCl: null,
        filterCn: null,
        filterVo: null,
        filterVn: null,

        filteri: null,
        filtere: null,
        filterE: null,
        filtera: null,
        filtery: null,
        filter2: null,
        filteree: null,
        filteroe: null,
        filtero: null,
        filteru: null,
        filterO: null,

        filter5: null,
        filterA: null,
        filterCC: null,

        filter8: null,
        filterW: null,
        filterJ: null,

        filterp: null,
        filterB: null,
        filterT: null,
        filterD: null,
        filterk: null,
        filterG: null,

        filterF: null,
        filterV: null,
        filters: null,
        filterz: null,
        filterS: null,
        filterZ: null,

        filterR: null,
        filterL: null,
        filterM: null,

        filtern: null,
        filterN: null,
        filterK: null
      },
      lists: {
        emptylist: {
          id: null,
          name: "...à partir d'une liste vide",
        },
        list1: {
          id: 1,
          name: "Premier travail",
        },
        list2: {
          id: 2,
          name: "Deuxième travail",
        },
        list3: {
          id: 3,
          name: "Troisième travail",
        },
        list4: {
          id: 4,
          name: "Quatrième travail",
        },
        list5: {
          id: 5,
          name: "Cinquième travail",
        },
      },
      words: [],
      filters: [
        {
          key: 0,
          label: "Nombre de syllabes",
          children: [
            {
              key: 34,
              label: "",
              data: "filterSyllabel",
              type: "syllabel",
            },
          ],
        },
        {
          key: 1,
          label: "Structure syllabique",
          children: [
            {
              key: 2,
              label: "CV",
              data: "filterCV",
              type: "checkbox",
            },
            {
              key: 3,
              label: "VC",
              data: "filterVC",
              type: "checkbox",
            },
            {
              key: 4,
              label: "CVCV",
              data: "filterCVCV",
              type: "checkbox",
            },
            {
              key: 5,
              label: "VCV",
              data: "filterVCV",
              type: "checkbox",
            },
            {
              key: 6,
              label: "CVC",
              data: "filterCVC",
              type: "checkbox",
            },
            {
              key: 7,
              label: "CVCVC",
              data: "filterCVCVC",
              type: "checkbox",
            },
            {
              key: 8,
              label: "CVV",
              data: "filterCVV",
              type: "checkbox",
            },
            {
              key: 9,
              label: "CC",
              children: [
                {
                  key: 10,
                  label: "CC initial",
                  data: "filterCC_init",
                  type: "checkbox",
                },
                {
                  key: 11,
                  label: "CC intérieur",
                  data: "filterCC_mid",
                  type: "checkbox",
                },
                {
                  key: 12,
                  label: "CC final",
                  data: "filterCC_final",
                  type: "checkbox",
                },
              ],
            },
            {
              key: 13,
              label: "CCC",
              children: [
                {
                  key: 14,
                  label: "CCC initial",
                  data: "filterCCC_init",
                  type: "checkbox",
                },
                {
                  key: 15,
                  label: "CCC intérieur",
                  data: "filterCCC_mid",
                  type: "checkbox",
                },
                {
                  key: 16,
                  label: "CCC final",
                  data: "filterCCC_final",
                  type: "checkbox",
                },
              ],
            },
            {
              key: 17,
              label: "Polysyllabique",
              data: "filterPolysyllab",
              type: "checkbox",
            },
            {
              key: 18,
              label: "V",
              data: "filterV",
              type: "checkbox",
            },
            {
              key: 19,
              label: "VCVC",
              data: "filterVCVC",
              type: "checkbox",
            },
            {
              key: 20,
              label: "VCVCV",
              data: "filterVCVCV",
              type: "checkbox",
            },
            {
              key: 21,
              label: "VCVCVC",
              data: "filterVCVCVC",
              type: "checkbox",
            },
          ],
        },
        {
          key: 22,
          label: "Famille de sons",
          children: [
            {
              key: 23,
              label: "Csv",
              data: "filterCsv",
              type: "checkbox",
            },
            {
              key: 24,
              label: "Co",
              children: [
                {
                  key: 25,
                  label: "Co sourdes",
                  data: "filterCo_sourd",
                  type: "checkbox",
                },
                {
                  key: 26,
                  label: "Co sonores",
                  data: "filterCo_sonore",
                  type: "checkbox",
                },
              ],
            },
            {
              key: 27,
              label: "Cc",
              children: [
                {
                  key: 28,
                  label: "Cc sourdes",
                  data: "filterCc_sourd",
                  type: "checkbox",
                },
                {
                  key: 29,
                  label: "Cc sonores",
                  data: "filterCc_sonore",
                  type: "checkbox",
                },
              ],
            },
            {
              key: 30,
              label: "Cl",
              data: "filterCl",
              type: "checkbox",
            },
            {
              key: 31,
              label: "Cn",
              data: "filterCn",
              type: "checkbox",
            },
            {
              key: 32,
              label: "Vo",
              data: "filterVo",
              type: "checkbox",
            },
            {
              key: 33,
              label: "Vn",
              data: "filterVn",
              type: "checkbox",
            },
          ],
        },
        {
          key: 35,
          label: "Phonèmes",
          children: [
            {
              key: 36,
              label: "i - voyelle orale",
              data: "filteri",
              type: "checkbox",
            },
            {
              key: 37,
              label: "e - voyelle orale",
              data: "filtere",
              type: "checkbox",
            },
            {
              key: 38,
              label: "ɛ - voyelle orale",
              data: "filterE",
              type: "checkbox",
            },
            {
              key: 39,
              label: "a - voyelle orale",
              data: "filtera",
              type: "checkbox",
            },
            {
              key: 40,
              label: "y - voyelle orale",
              data: "filtery",
              type: "checkbox",
            },
            {
              key: 41,
              label: "ø - voyelle orale",
              data: "filter2",
              type: "checkbox",
            },
            {
              key: 42,
              label: "ə - voyelle orale",
              data: "filteree",
              type: "checkbox",
            },
            {
              key: 43,
              label: "œ - voyelle orale",
              data: "filteroe",
              type: "checkbox",
            },
            {
              key: 44,
              label: "u - voyelle orale",
              data: "filteru",
              type: "checkbox",
            },
            {
              key: 45,
              label: "o - voyelle orale",
              data: "filtero",
              type: "checkbox",
            },
            {
              key: 46,
              label: "ɔ - voyelle orale",
              data: "filterO",
              type: "checkbox",
            },
            {},
            {
              key: 47,
              label: "ɛ̃ - voyelle nasale",
              data: "filter5",
              type: "checkbox",
            },
            {
              key: 48,
              label: "ɑ̃ - voyelle nasale",
              data: "filterA",
              type: "checkbox",
            },
            {
              key: 49,
              label: "ɔ̃ - voyelle nasale",
              data: "filterCC",
              type: "checkbox",
            },
            {},
            {
              key: 50,
              label: "ɥ - semi-consonne",
              data: "filter8",
              type: "checkbox",
            },
            {
              key: 51,
              label: "w - semi-consonne",
              data: "filterW",
              type: "checkbox",
            },
            {
              key: 52,
              label: "j - semi-consonne",
              data: "filterJ",
              type: "checkbox",
            },
            {},
            {
              key: 53,
              label: "p - consonne sourde",
              data: "filterp",
              type: "checkbox",
            },
            {
              key: 54,
              label: "b - consonne sonore",
              data: "filterB",
              type: "checkbox",
            },
            {
              key: 55,
              label: "t - consonne sourde",
              data: "filterT",
              type: "checkbox",
            },
            {
              key: 56,
              label: "d - consonne sonore",
              data: "filterD",
              type: "checkbox",
            },
            {
              key: 57,
              label: "k - consonne sourde",
              data: "filterk",
              type: "checkbox",
            },
            {
              key: 58,
              label: "g - consonne sonore",
              data: "filterG",
              type: "checkbox",
            },
            {
              key: 59,
              label: "f - consonne sourde",
              data: "filterF",
              type: "checkbox",
            },
            {
              key: 60,
              label: "v - consonne sonore",
              data: "filterV",
              type: "checkbox",
            },
            {
              key: 61,
              label: "s - consonne sourde",
              data: "filters",
              type: "checkbox",
            },
            {
              key: 62,
              label: "z - consonne sonore",
              data: "filterz",
              type: "checkbox",
            },
            {
              key: 63,
              label: "ʃ - consonne sourde",
              data: "filterS",
              type: "checkbox",
            },
            {
              key: 64,
              label: "ʒ - consonne sonore",
              data: "filterZ",
              type: "checkbox",
            },
            {
              key: 65,
              label: "ʁ - consonne",
              data: "filterR",
              type: "checkbox",
            },
            {
              key: 66,
              label: "l - consonne",
              data: "filterL",
              type: "checkbox",
            },
            {
              key: 67,
              label: "m - consonne",
              data: "filterM",
              type: "checkbox",
            },
            {
              key: 68,
              label: "n - consonne",
              data: "filtern",
              type: "checkbox",
            },
            {
              key: 69,
              label: "ɲ - consonne",
              data: "filterN",
              type: "checkbox",
            },
            {
              key: 70,
              label: "ŋ - consonne",
              data: "filterK",
              type: "checkbox",
            },
          ],
        },
      ],
    };
  },
  created() {
    if (!this.$store.state.user.isLoggedIn) {
      this.$router.push('/')
    } else {
      this.initPage()
      this.getPatient()
    }
  },
  methods: {
    async getPatient() {
      await axios
        .get("/enfants/search?id_ortho="+ this.$store.state.user.id +"&enfant_id=" + this.$route.params.id)
        .then((res) => {
          this.patient = res.data[0]
        })
        .catch((error) => {
          this.$router.push('/panel')
        });
    },
    async removeFilter() {
      this.loadFilter = true
      if (this.patient.isWorking && this.patient.work == this.$route.params.word) {
        await axios.post("/filtres/work/remove", {enfant_id: this.$route.params.id}).then(res => {
          this.patient.isWorking = false
        }).catch(err => {
          console.log(err)
        })
      }
      await axios.delete("/filtres/remove?filtre_id=" + this.$route.params.word + "&id_ortho=" + this.$store.state.user.id).then(response => {
        this.$router.push("/patient/" + this.$route.params.id)
      })
    },
    addAll() {
      for (let i = 0; i < this.computedWords.length; i++) {
        if (!(this.computedWords[i].id in this.selectWords)) {
          this.selectWords[this.computedWords[i].id] = {id: this.computedWords[i].id, phonem: this.computedWords[i].phonem, orthographe: this.computedWords[i].orthographe, nb_syll: this.computedWords[i].nb_syll, struct_syll: this.computedWords[i].struct_syll, struct_syll_type: this.computedWords[i].struct_syll_type}
        }
      }
    },
    async saveModification() {
      this.submitError = null
      this.submitLoad = true
      let wl = []
      Object.keys(this.selectWords || {}).forEach(item => {
        wl.push(String(this.selectWords[item].id))
      })
      let collName = ""
      if (this.collab) {
        collName = String(this.$store.state.user.prenom) + " " + String(this.$store.state.user.nom).substring(0, 1) + String(".")
      }
      await axios.post("/filtres/update", {wordList: wl.join(","), collaborative: this.collab, collaborativeName: collName, id: this.$route.params.word}).then(res => {
        this.$router.push("/patient/" + this.$route.params.id)
      }).catch(err => {
        this.submitError = err.data.detail
        this.submitLoad = false
      })
    },
    async submitWordList() {
      this.submitError = null
      this.submitLoad = true
      let wl = []
      Object.keys(this.selectWords || {}).forEach(item => {
        wl.push(String(this.selectWords[item].id))
      })
      let collName = ""
      if (this.collab) {
        collName = String(this.$store.state.user.prenom) + " " + String(this.$store.state.user.nom).substring(0, 1) + String(".")
      }
      await axios.put("/filtres/create", {nom: this.listName, collaborative: this.collab, collaborativeName: collName, wordList: wl.join(","), id_ortho: this.$store.state.user.id, enfant_id: this.$route.params.id}).then(res => {
        this.$router.push("/patient/" + this.$route.params.id)
      }).catch(err => {
        this.submitError = err.data.detail
        this.submitLoad = false
      })
    },
    async initPage() {
      await axios.post("/mots/check", {bdd_version: this.$store.state.motsVersion}).then(res => {
            if (!res.data.valid) {
              this.$store.commit('importMots', {mots: res.data.complete.mots, bdd_version: res.data.complete.bdd_version})
            }
            this.words = this.$store.state.mots
          }).catch(err => {
            console.log(err)
          })
      if (this.$route.params.word != "new" && !this.$route.name.includes('collab')) {
        await axios.get("/filtres/" + this.$store.state.user.id + "/" + this.$route.params.word).then(res => {
          let wl = String(res.data.wordList).split(",")
          let alWord = 0
          for (let i = 0; i < this.$store.state.mots.length; i++) {
            if (alWord == wl.length) {
              break;
            }
            if (wl.includes(String(this.$store.state.mots[i].id))) {
              alWord++;
              this.selectWords[this.$store.state.mots[i].id] = {id: this.$store.state.mots[i].id, phonem: this.$store.state.mots[i].phonem, orthographe: this.$store.state.mots[i].orthographe, nb_syll: this.$store.state.mots[i].nb_syll, struct_syll: this.$store.state.mots[i].struct_syll, struct_syll_type: this.$store.state.mots[i].struct_syll_type}
            }
          }
          if (res.data.collaborative) {
            this.collab = true
          }
          this.filterName = res.data.nom
        }).catch(err => {
          console.log(err)
        })
      } else if (this.$route.name.includes('collab')) {
        await axios.get("/filtres/" + this.$route.params.word + "/c/collab").then(res => {
          let wl = String(res.data.wordList).split(",")
          let alWord = 0
          for (let i = 0; i < this.$store.state.mots.length; i++) {
            if (alWord == wl.length) {
              break;
            }
            if (wl.includes(String(this.$store.state.mots[i].id))) {
              alWord++;
              this.selectWords[this.$store.state.mots[i].id] = {id: this.$store.state.mots[i].id, phonem: this.$store.state.mots[i].phonem, orthographe: this.$store.state.mots[i].orthographe, nb_syll: this.$store.state.mots[i].nb_syll, struct_syll: this.$store.state.mots[i].struct_syll, struct_syll_type: this.$store.state.mots[i].struct_syll_type}
            }
          }
          if (res.data.collaborative) {
            this.collab = true
          }
          this.filterName = res.data.nom
        }).catch(err => {
          console.log(err)
        })
      }
    }
  },
  computed: {
    Syllab() {
      if (this.filterModels.filterSyllabel) {
        return this.words.filter((word) => word.nb_syll == this.filterModels.filterSyllabel)
      } else {
        return this.words
      }
    },
    CV() {
      if (this.filterModels.filterCV) {
        return this.Syllab.filter((word) => String(word.struct_syll) == 'CV')
      } else if (this.filterModels.filterCV == false) {
        return this.Syllab.filter((word) => String(word.struct_syll) != 'CV')
      } else {
        return this.Syllab
      }
    },
    VC() {
      if (this.filterModels.filterVC) {
        return this.CV.filter((word) => String(word.struct_syll) == 'VC')
      } else if (this.filterModels.filterVC == false) {
        return this.CV.filter((word) => String(word.struct_syll) != 'VC')
      } else {
        return this.CV
      }
    },
    CVCV() {
      if (this.filterModels.filterCVCV) {
        return this.VC.filter((word) => String(word.struct_syll) == 'CVCV')
      } else if (this.filterModels.filterCVCV == false) {
        return this.VC.filter((word) => String(word.struct_syll) != 'CVCV')
      } else {
        return this.VC
      }
    },
    VCV() {
      if (this.filterModels.filterVCV) {
        return this.CVCV.filter((word) => String(word.struct_syll) == 'VCV')
      } else if (this.filterModels.filterVCV == false) {
        return this.CVCV.filter((word) => String(word.struct_syll) != 'VCV')
      } else {
        return this.CVCV
      }
    },
    CVC() {
      if (this.filterModels.filterCVC) {
        return this.VCV.filter((word) => String(word.struct_syll) == 'CVC')
      } else if (this.filterModels.filterCVC == false) {
        return this.VCV.filter((word) => String(word.struct_syll) != 'CVC')
      } else {
        return this.VCV
      }
    },
    CVCVC() {
      if (this.filterModels.filterCVCVC) {
        return this.CVC.filter((word) => String(word.struct_syll) == 'CVCVC')
      } else if (this.filterModels.filterCVCVC == false) {
        return this.CVC.filter((word) => String(word.struct_syll) != 'CVCVC')
      } else {
        return this.CVC
      }
    },
    CVV() {
      if (this.filterModels.filterCVV) {
        return this.CVCVC.filter((word) => String(word.struct_syll) == 'CVV')
      } else if (this.filterModels.filterCVV == false) {
        return this.CVCVC.filter((word) => String(word.struct_syll) != 'CVV')
      } else {
        return this.CVCVC
      }
    },
    V() {
      if (this.filterModels.filterV) {
        return this.CVV.filter((word) => String(word.struct_syll) == 'V')
      } else if (this.filterModels.filterV == false) {
        return this.CVV.filter((word) => String(word.struct_syll) != 'V')
      } else {
        return this.CVV
      }
    },
    CCInitial() {
      if (this.filterModels.filterCC_init) {
        return this.V.filter((word) => String(word.struct_syll).startsWith('CC'))
      } else if (this.filterModels.filterCC_init == false) {
        return this.V.filter((word) => !String(word.struct_syll).startsWith('CC'))
      } else {
        return this.V
      }
    },
    CCInterieur() {
      if (this.filterModels.filterCC_mid) {
        return this.CCInitial.filter((word) => String(word.struct_syll).includes('CC'))
      } else if (this.filterModels.filterCC_mid == false) {
        return this.CCInitial.filter((word) => !String(word.struct_syll).includes('CC'))
      } else {
        return this.CCInitial
      }
    },
    CCFinal() {
      if (this.filterModels.filterCC_final) {
        return this.CCInterieur.filter((word) => String(word.struct_syll).endsWith('CC'))
      } else if (this.filterModels.filterCC_final == false) {
        return this.CCInterieur.filter((word) => !String(word.struct_syll).endsWith('CC'))
      } else {
        return this.CCInterieur
      }
    },
    CCCInitial() {
      if (this.filterModels.filterCCC_init) {
        return this.CCFinal.filter((word) => String(word.struct_syll).startsWith('CCC'))
      } else if (this.filterModels.filterCCC_init == false) {
        return this.CCFinal.filter((word) => !String(word.struct_syll).startsWith('CCC'))
      } else {
        return this.CCFinal
      }
    },
    CCCInterieur() {
      if (this.filterModels.filterCCC_mid) {
        return this.CCCInitial.filter((word) => String(word.struct_syll).includes('CCC'))
      } else if (this.filterModels.filterCCC_mid == false) {
        return this.CCCInitial.filter((word) => !String(word.struct_syll).includes('CCC'))
      } else {
        return this.CCCInitial
      }
    },
    CCCFinal() {
      if (this.filterModels.filterCCC_final) {
        return this.CCCInterieur.filter((word) => String(word.struct_syll).endsWith('CCC'))
      } else if (this.filterModels.filterCCC_final == false) {
        return this.CCCInterieur.filter((word) => !String(word.struct_syll).endsWith('CCC'))
      } else {
        return this.CCCInterieur
      }
    },
    Polysyll() {
      if (this.filterModels.filterPolysyllab) {
        return this.CCCFinal.filter((word) => word.poly_syll)
      } else if (this.filterModels.filterPolysyllab == false) {
        return this.CCCFinal.filter((word) => !word.poly_syll)
      } else {
        return this.CCCFinal
      }
    },

    VCVC() {
      if (this.filterModels.filterVCVC) {
        return this.Polysyll.filter((word) => String(word.struct_syll) == 'VCVC')
      } else if (this.filterModels.filterVCVC == false) {
        return this.Polysyll.filter((word) => String(word.struct_syll) != 'VCVC')
      } else {
        return this.Polysyll
      }
    },
    VCVCV() {
      if (this.filterModels.filterVCVCV) {
        return this.VCVC.filter((word) => String(word.struct_syll) == 'VCVCV')
      } else if (this.filterModels.filterVCVCV == false) {
        return this.VCVC.filter((word) => String(word.struct_syll) != 'VCVCV')
      } else {
        return this.VCVC
      }
    },
    VCVCVC() {
      if (this.filterModels.filterVCVCVC) {
        return this.VCVCV.filter((word) => String(word.struct_syll) == 'VCVCVC')
      } else if (this.filterModels.filterVCVCVC == false) {
        return this.VCVCV.filter((word) => String(word.struct_syll) != 'VCVCVC')
      } else {
        return this.VCVCV
      }
    },

    CoSourde() {
      if (this.filterModels.filterCo_sourd) {
        return this.VCVCVC.filter((word) => String(word.phonem).includes('p') || String(word.phonem).includes('t') || String(word.phonem).includes('k'))
      } else if (this.filterModels.filterCo_sourd == false) {
        return this.VCVCVC.filter((word) => !String(word.phonem).includes('p') && !String(word.phonem).includes('t') && !String(word.phonem).includes('k'))
      } else {
        return this.VCVCVC
      }
    },
    CoSonore() {
      if (this.filterModels.filterCo_sonore) {
        return this.CoSourde.filter((word) => String(word.phonem).includes('b') || String(word.phonem).includes('d') || String(word.phonem).includes('g'))
      } else if (this.filterModels.filterCo_sonore == false) {
        return this.CoSourde.filter((word) => !String(word.phonem).includes('b') && !String(word.phonem).includes('d') && !String(word.phonem).includes('g'))
      } else {
        return this.CoSourde
      }
    },
    CcSonore() {
      if (this.filterModels.filterCc_sonore) {
        return this.CoSonore.filter((word) => String(word.phonem).includes('v') || String(word.phonem).includes('z') || String(word.phonem).includes('Z'))
      } else if (this.filterModels.filterCc_sonore == false) {
        return this.CoSonore.filter((word) => !String(word.phonem).includes('v') && !String(word.phonem).includes('z') && !String(word.phonem).includes('Z'))
      } else {
        return this.CoSonore
      }
    },
    CcSourde() {
      if (this.filterModels.filterCc_sourd) {
        return this.CcSonore.filter((word) => String(word.phonem).includes('f') || String(word.phonem).includes('s') || String(word.phonem).includes('S'))
      } else if (this.filterModels.filterCc_sourd == false) {
        return this.CcSonore.filter((word) => !String(word.phonem).includes('f') && !String(word.phonem).includes('s') && !String(word.phonem).includes('S'))
      } else {
        return this.CcSonore
      }
    },
    Cl() {
      if (this.filterModels.filterCl) {
        return this.CcSourde.filter((word) => String(word.struct_syll_type).includes('Cl'))
      } else if (this.filterModels.filterCl == false) {
        return this.CcSourde.filter((word) => !String(word.struct_syll_type).includes('Cl'))
      } else {
        return this.CcSourde
      }
    },
    Cn() {
      if (this.filterModels.filterCn) {
        return this.Cl.filter((word) => String(word.struct_syll_type).includes('Cn'))
      } else if (this.filterModels.filterCn == false) {
        return this.Cl.filter((word) => !String(word.struct_syll_type).includes('Cn'))
      } else {
        return this.Cl
      }
    },
    Vo() {
      if (this.filterModels.filterVo) {
        return this.Cn.filter((word) => String(word.struct_syll_type).includes('Vo'))
      } else if (this.filterModels.filterVo == false) {
        return this.Cn.filter((word) => !String(word.struct_syll_type).includes('Vo'))
      } else {
        return this.Cn
      }
    },
    Vn() {
      if (this.filterModels.filterVn) {
        return this.Vo.filter((word) => String(word.struct_syll_type).includes('Vn'))
      } else if (this.filterModels.filterVn == false) {
        return this.Vo.filter((word) => !String(word.struct_syll_type).includes('Vn'))
      } else {
        return this.Vo
      }
    },
    Csv() {
      if (this.filterModels.filterCsv) {
        return this.Vn.filter((word) => String(word.struct_syll_type).includes('Csv'))
      } else if (this.filterModels.filterCsv == false) {
        return this.Vn.filter((word) => !String(word.struct_syll_type).includes('Csv'))
      } else {
        return this.Vn
      }
    },
    fi() {
      if (this.filterModels.filteri) {
        return this.Csv.filter((word) => String(word.phonem).includes('i'))
      } else if (this.filterModels.filteri == false) {
        return this.Csv.filter((word) => !String(word.phonem).includes('i'))
      } else {
        return this.Csv
      }
    },
    fe() {
      if (this.filterModels.filtere) {
        return this.fi.filter((word) => String(word.phonem).includes('e'))
      } else if (this.filterModels.filtere == false) {
        return this.fi.filter((word) => !String(word.phonem).includes('e'))
      } else {
        return this.fi
      }
    },
    fE() {
      if (this.filterModels.filterE) {
        return this.fe.filter((word) => String(word.phonem).includes('E'))
      } else if (this.filterModels.filterE == false) {
        return this.fe.filter((word) => !String(word.phonem).includes('E'))
      } else {
        return this.fe
      }
    },
    fa() {
      if (this.filterModels.filtera) {
        return this.fE.filter((word) => String(word.phonem).includes('a'))
      } else if (this.filterModels.filtera == false) {
        return this.fE.filter((word) => !String(word.phonem).includes('a'))
      } else {
        return this.fE
      }
    },
    fy() {
      if (this.filterModels.filtery) {
        return this.fa.filter((word) => String(word.phonem).includes('y'))
      } else if (this.filterModels.filtery == false) {
        return this.fa.filter((word) => !String(word.phonem).includes('y'))
      } else {
        return this.fa
      }
    },
    f2() {
      if (this.filterModels.filter2) {
        return this.fy.filter((word) => String(word.phonem).includes('2'))
      } else if (this.filterModels.filter2 == false) {
        return this.fy.filter((word) => !String(word.phonem).includes('2'))
      } else {
        return this.fy
      }
    },
    fee() {
      if (this.filterModels.filteree) {
        return this.f2.filter((word) => String(word.phonem).includes('°'))
      } else if (this.filterModels.filteree == false) {
        return this.f2.filter((word) => !String(word.phonem).includes('°'))
      } else {
        return this.f2
      }
    },
    foe() {
      if (this.filterModels.filteroe) {
        return this.fee.filter((word) => String(word.phonem).includes('9'))
      } else if (this.filterModels.filteroe == false) {
        return this.fee.filter((word) => !String(word.phonem).includes('9'))
      } else {
        return this.fee
      }
    },
    fo() {
      if (this.filterModels.filtero) {
        return this.foe.filter((word) => String(word.phonem).includes('o'))
      } else if (this.filterModels.filtero == false) {
        return this.foe.filter((word) => !String(word.phonem).includes('o'))
      } else {
        return this.foe
      }
    },
    fu() {
      if (this.filterModels.filteru) {
        return this.fo.filter((word) => String(word.phonem).includes('u'))
      } else if (this.filterModels.filteru == false) {
        return this.fo.filter((word) => !String(word.phonem).includes('u'))
      } else {
        return this.fo
      }
    },
    fO() {
      if (this.filterModels.filterO) {
        return this.fu.filter((word) => String(word.phonem).includes('O'))
      } else if (this.filterModels.filterO == false) {
        return this.fu.filter((word) => !String(word.phonem).includes('O'))
      } else {
        return this.fu
      }
    },
    f5() {
      if (this.filterModels.filter5) {
        return this.fO.filter((word) => String(word.phonem).includes('5'))
      } else if (this.filterModels.filter5 == false) {
        return this.fO.filter((word) => !String(word.phonem).includes('5'))
      } else {
        return this.fO
      }
    },
    fA() {
      if (this.filterModels.filterA) {
        return this.f5.filter((word) => String(word.phonem).includes('@'))
      } else if (this.filterModels.filterA == false) {
        return this.f5.filter((word) => !String(word.phonem).includes('@'))
      } else {
        return this.f5
      }
    },
    fCC() {
      if (this.filterModels.filterCC) {
        return this.fA.filter((word) => String(word.phonem).includes('§'))
      } else if (this.filterModels.filterCC == false) {
        return this.fA.filter((word) => !String(word.phonem).includes('§'))
      } else {
        return this.fA
      }
    },
    f8() {
      if (this.filterModels.filter7) {
        return this.fCC.filter((word) => String(word.phonem).includes('8'))
      } else if (this.filterModels.filter8 == false) {
        return this.fCC.filter((word) => !String(word.phonem).includes('8'))
      } else {
        return this.fCC
      }
    },
    fW() {
      if (this.filterModels.filterW) {
        return this.f8.filter((word) => String(word.phonem).includes('w'))
      } else if (this.filterModels.filterW == false) {
        return this.f8.filter((word) => !String(word.phonem).includes('w'))
      } else {
        return this.f8
      }
    },
    fJ() {
      if (this.filterModels.filterJ) {
        return this.fW.filter((word) => String(word.phonem).includes('j'))
      } else if (this.filterModels.filterJ == false) {
        return this.fW.filter((word) => !String(word.phonem).includes('j'))
      } else {
        return this.fW
      }
    },
    fp() {
      if (this.filterModels.filterp) {
        return this.fJ.filter((word) => String(word.phonem).includes('p'))
      } else if (this.filterModels.filterp == false) {
        return this.fJ.filter((word) => !String(word.phonem).includes('p'))
      } else {
        return this.fJ
      }
    },
    fB() {
      if (this.filterModels.filterB) {
        return this.fp.filter((word) => String(word.phonem).includes('b'))
      } else if (this.filterModels.filterB == false) {
        return this.fp.filter((word) => !String(word.phonem).includes('b'))
      } else {
        return this.fp
      }
    },
    fT() {
      if (this.filterModels.filterT) {
        return this.fB.filter((word) => String(word.phonem).includes('t'))
      } else if (this.filterModels.filterT == false) {
        return this.fB.filter((word) => !String(word.phonem).includes('t'))
      } else {
        return this.fB
      }
    },
    fD() {
      if (this.filterModels.filterD) {
        return this.fT.filter((word) => String(word.phonem).includes('D'))
      } else if (this.filterModels.filterD == false) {
        return this.fT.filter((word) => !String(word.phonem).includes('d'))
      } else {
        return this.fT
      }
    },
    fk() {
      if (this.filterModels.filterk) {
        return this.fD.filter((word) => String(word.phonem).includes('k'))
      } else if (this.filterModels.filterk == false) {
        return this.fD.filter((word) => !String(word.phonem).includes('k'))
      } else {
        return this.fD
      }
    },
    fG() {
      if (this.filterModels.filterG) {
        return this.fk.filter((word) => String(word.phonem).includes('g'))
      } else if (this.filterModels.filterG == false) {
        return this.fk.filter((word) => !String(word.phonem).includes('g'))
      } else {
        return this.fk
      }
    },
    fF() {
      if (this.filterModels.filterF) {
        return this.fG.filter((word) => String(word.phonem).includes('f'))
      } else if (this.filterModels.filterF == false) {
        return this.fG.filter((word) => !String(word.phonem).includes('f'))
      } else {
        return this.fG
      }
    },
    fV() {
      if (this.filterModels.filterV) {
        return this.fF.filter((word) => String(word.phonem).includes('v'))
      } else if (this.filterModels.filterV == false) {
        return this.fF.filter((word) => !String(word.phonem).includes('v'))
      } else {
        return this.fF
      }
    },
    fs() {
      if (this.filterModels.filters) {
        return this.fV.filter((word) => String(word.phonem).includes('s'))
      } else if (this.filterModels.filters == false) {
        return this.fV.filter((word) => !String(word.phonem).includes('s'))
      } else {
        return this.fV
      }
    },
    fz() {
      if (this.filterModels.filterz) {
        return this.fs.filter((word) => String(word.phonem).includes('z'))
      } else if (this.filterModels.filterz == false) {
        return this.fs.filter((word) => !String(word.phonem).includes('z'))
      } else {
        return this.fs
      }
    },
    fS() {
      if (this.filterModels.filterS) {
        return this.fz.filter((word) => String(word.phonem).includes('S'))
      } else if (this.filterModels.filterS == false) {
        return this.fz.filter((word) => !String(word.phonem).includes('S'))
      } else {
        return this.fz
      }
    },
    fZ() {
      if (this.filterModels.filterZ) {
        return this.fS.filter((word) => String(word.phonem).includes('Z'))
      } else if (this.filterModels.filterZ == false) {
        return this.fS.filter((word) => !String(word.phonem).includes('Z'))
      } else {
        return this.fS
      }
    },
    fR() {
      if (this.filterModels.filterR) {
        return this.fZ.filter((word) => String(word.phonem).includes('R'))
      } else if (this.filterModels.filterR == false) {
        return this.fZ.filter((word) => !String(word.phonem).includes('R'))
      } else {
        return this.fZ
      }
    },
    fL() {
      if (this.filterModels.filterL) {
        return this.fR.filter((word) => String(word.phonem).includes('l'))
      } else if (this.filterModels.filterL == false) {
        return this.fR.filter((word) => !String(word.phonem).includes('l'))
      } else {
        return this.fR
      }
    },
    fM() {
      if (this.filterModels.filterM) {
        return this.fL.filter((word) => String(word.phonem).includes('m'))
      } else if (this.filterModels.filterM == false) {
        return this.fL.filter((word) => !String(word.phonem).includes('m'))
      } else {
        return this.fL
      }
    },
    fn() {
      if (this.filterModels.filtern) {
        return this.fM.filter((word) => String(word.phonem).includes('n'))
      } else if (this.filterModels.filtern == false) {
        return this.fM.filter((word) => !String(word.phonem).includes('n'))
      } else {
        return this.fM
      }
    },
    fN() {
      if (this.filterModels.filterN) {
        return this.fn.filter((word) => String(word.phonem).includes('N'))
      } else if (this.filterModels.filterN == false) {
        return this.fn.filter((word) => !String(word.phonem).includes('N'))
      } else {
        return this.fn
      }
    },
    fK() {
      if (this.filterModels.filterK) {
        return this.fN.filter((word) => String(word.phonem).includes('K'))
      } else if (this.filterModels.filterK == false) {
        return this.fN.filter((word) => !String(word.phonem).includes('K'))
      } else {
        return this.fN
      }
    },
    sortWords() {
      return this.fK.sort((a, b) => a.orthographe.localeCompare(b.orthographe))
    },
    computedWords() {
      if (this.searchWordDico.length > 0) {
        return this.sortWords.filter((word) => String(String(word.orthographe).toLowerCase()).includes(this.searchWordDico.toLowerCase())) 
      } else {
        return this.sortWords
      }
    },
    computedSortResult() {
      let ret = []
      Object.keys(this.selectWords || {}).forEach(item => {
        ret.push({id: this.selectWords[item].id, phonem: this.selectWords[item].phonem, orthographe: this.selectWords[item].orthographe, nb_syll: this.selectWords[item].nb_syll, struct_syll: this.selectWords[item].struct_syll, struct_syll_type: this.selectWords[item].struct_syll_type})
      })
      return ret.sort((a, b) => String(b.orthographe) - String(a.orthographe))
    },
    computedResult() {
      return this.computedSortResult.filter((word) => String(String(word.orthographe).toLowerCase()).includes(this.searchWordResult.toLowerCase()))
    }
  },
};
</script>

<style lang="scss">
.mainTable {
  border: 2px solid #F0F0F0;
  height: 340px;
  overflow-y: auto;
  overflow-x: hidden;
}
.selectTable {
  border: 2px solid #F0F0F0;
  height: 200px;
  overflow-y: auto;
  overflow-x: hidden;
}
.gridTwo {
  padding: 5px 0px;
  display: grid;
  gap: 1rem;
  grid-template-columns: repeat(2, minmax(0, 1fr));
}
.gridElem {
  height: 32px;
  display: flex;
  align-items: center;
  justify-content: center;
}
.gridFive {
  padding: 5px 0px;
  display: grid;
  gap: 1rem;
  grid-template-columns: repeat(5, minmax(0, 1fr));
}
.gridFive:hover {
  background-color: #F0F0F0;
}

.wordlist-tree {
  background-color: rgb(0, 2, 94);
  color: white;
  margin-top: 0.5rem;
  height: 590px;
}

.wordlist-button {
  display: flex;
  align-items: flex-start;
  justify-content: center;
}

.p-tree {
  border: none !important;
  background-color: rgb(0, 2, 94) !important;
  color: white !important;
}

.p-tree-wrapper {
  height: 540px;
}

.p-treenode-content:hover {
  background-color: darken(rgb(0, 2, 94), 5) !important;
  color: white !important;
}

.treenode-label {
  margin-left: -2.5rem;
}

.p-column-header-content {
  justify-content: center;
}

.p-datatable-wrapper {
  height: 540px;
}

.p-datatable-tbody > tr > td {
  text-align: center !important;
  border: none !important;
}
</style>